/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 */
package blanco.nlpack.generator.task;

import java.io.IOException;

import blanco.nlpack.generator.task.valueobject.BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput;

/**
 * バッチ処理クラス [BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess]。
 *
 *
 * バッチ処理の呼び出し例。
 * <code>
 * java -classpath (クラスパス) blanco.nlpack.generator.task.BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess -help
 * </code>
 */
public class BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess {
    /**
     * 正常終了。
     */
    public static final int END_SUCCESS = 0;

    /**
     * 入力異常終了。内部的にjava.lang.IllegalArgumentExceptionが発生した場合。
     */
    public static final int END_ILLEGAL_ARGUMENT_EXCEPTION = 7;

    /**
     * 入出力例外終了。内部的にjava.io.IOExceptionが発生した場合。
     */
    public static final int END_IO_EXCEPTION = 8;

    /**
     * 異常終了。バッチの処理開始に失敗した場合、および内部的にjava.lang.Errorまたはjava.lang.RuntimeExceptionが発生した場合。
     */
    public static final int END_ERROR = 9;

    /**
     * コマンドラインから実行された際のエントリポイントです。
     *
     * @param args コンソールから引き継がれた引数。
     */
    public static final void main(final String[] args) {
        final BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess batchProcess = new BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess();

        // バッチ処理の引数。
        final BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput input = new BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput();

        boolean isNeedUsage = false;

        // コマンドライン引数の解析をおこないます。
        for (int index = 0; index < args.length; index++) {
            String arg = args[index];
            if (arg.startsWith("-verbose=")) {
                input.setVerbose(Boolean.valueOf(arg.substring(9)).booleanValue());
            } else if (arg.startsWith("-sourcefile=")) {
                input.setSourcefile(arg.substring(12));
            } else if (arg.startsWith("-targetfile=")) {
                input.setTargetfile(arg.substring(12));
            } else if (arg.startsWith("-sourcedir=")) {
                input.setSourcedir(arg.substring(11));
            } else if (arg.startsWith("-targetdir=")) {
                input.setTargetdir(arg.substring(11));
            } else if (arg.startsWith("-contributor=")) {
                input.setContributor(arg.substring(13));
            } else if (arg.startsWith("-isoutputdate=")) {
                input.setIsoutputdate(Boolean.valueOf(arg.substring(14)).booleanValue());
            } else if (arg.startsWith("-ischeckbundleuriasbabel=")) {
                input.setIscheckbundleuriasbabel(Boolean.valueOf(arg.substring(25)).booleanValue());
            } else if (arg.equals("-?") || arg.equals("-help")) {
                usage();
                System.exit(END_SUCCESS);
            } else {
                System.out.println("BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess: 入力パラメータ[" + arg + "]は無視されました。");
                isNeedUsage = true;
            }
        }

        if (isNeedUsage) {
            usage();
        }

        int retCode = batchProcess.execute(input);

        // 終了コードを戻します。
        // ※注意：System.exit()を呼び出している点に注意してください。
        System.exit(retCode);
    }

    /**
     * 具体的なバッチ処理内容を記述するためのメソッドです。
     *
     * このメソッドに実際の処理内容を記述します。
     *
     * @param input バッチ処理の入力パラメータ。
     * @return バッチ処理の終了コード。END_SUCCESS, END_ILLEGAL_ARGUMENT_EXCEPTION, END_IO_EXCEPTION, END_ERROR のいずれかの値を戻します。
     * @throws IOException 入出力例外が発生した場合。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public int process(final BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput input) throws IOException, IllegalArgumentException {
        // 入力パラメータをチェックします。
        validateInput(input);

        // この箇所でコンパイルエラーが発生する場合、BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessインタフェースを実装して blanco.nlpack.generator.taskパッケージに BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessImplクラスを作成することにより解決できる場合があります。
        final BlancoNLpackGeneratorTranslationFragmentToPleiadesProcess process = new BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessImpl();

        // 処理の本体を実行します。
        final int retCode = process.execute(input);

        return retCode;
    }

    /**
     * クラスをインスタンス化してバッチを実行する際のエントリポイントです。
     *
     * このメソッドは下記の仕様を提供します。
     * <ul>
     * <li>メソッドの入力パラメータの内容チェック。
     * <li>IllegalArgumentException, RuntimeException, Errorなどの例外をcatchして戻り値へと変換。
     * </ul>
     *
     * @param input バッチ処理の入力パラメータ。
     * @return バッチ処理の終了コード。END_SUCCESS, END_ILLEGAL_ARGUMENT_EXCEPTION, END_IO_EXCEPTION, END_ERROR のいずれかの値を戻します。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public final int execute(final BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput input) throws IllegalArgumentException {
        try {
            // バッチ処理の本体を実行します。
            int retCode = process(input);

            return retCode;
        } catch (IllegalArgumentException ex) {
            System.out.println("BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess: 入力例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            // 入力異常終了。
            return END_ILLEGAL_ARGUMENT_EXCEPTION;
        } catch (IOException ex) {
            System.out.println("BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess: 入出力例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            // 入力異常終了。
            return END_IO_EXCEPTION;
        } catch (RuntimeException ex) {
            System.out.println("BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess: ランタイム例外が発生しました。バッチ処理を中断します。:" + ex.toString());
            ex.printStackTrace();
            // 異常終了。
            return END_ERROR;
        } catch (Error er) {
            System.out.println("BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess: ランタイムエラーが発生しました。バッチ処理を中断します。:" + er.toString());
            er.printStackTrace();
            // 異常終了。
            return END_ERROR;
        }
    }

    /**
     * このバッチ処理クラスの使い方の説明を標準出力に示すためのメソッドです。
     */
    public static final void usage() {
        System.out.println("BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess: Usage:");
        System.out.println("  java blanco.nlpack.generator.task.BlancoNLpackGeneratorTranslationFragmentToPleiadesBatchProcess -verbose=値1 -sourcefile=値2 -targetfile=値3 -sourcedir=値4 -targetdir=値5 -contributor=値6 -isoutputdate=値7 -ischeckbundleuriasbabel=値8");
        System.out.println("    -verbose");
        System.out.println("      説明[verboseモードで動作させるかどうか。]");
        System.out.println("      型[真偽]");
        System.out.println("      デフォルト値[false]");
        System.out.println("    -sourcefile");
        System.out.println("      説明[入力ファイル。]");
        System.out.println("      型[文字列]");
        System.out.println("      デフォルト値[conf/BlancoNLpackGeneratorTranslationFragment.csv]");
        System.out.println("    -targetfile");
        System.out.println("      説明[出力ファイル。]");
        System.out.println("      型[文字列]");
        System.out.println("      デフォルト値[tmp/BlancoNLpackGeneratorTranslationFragment.properties]");
        System.out.println("    -sourcedir");
        System.out.println("      説明[入力ファイルが格納されたディレクトリ。sourcefileかいずれかを指定。]");
        System.out.println("      型[文字列]");
        System.out.println("    -targetdir");
        System.out.println("      説明[出力ファイルが格納されたディレクトリ。targetfileかいずれかを指定。]");
        System.out.println("      型[文字列]");
        System.out.println("    -contributor");
        System.out.println("      説明[貢献者の名前。]");
        System.out.println("      型[文字列]");
        System.out.println("      デフォルト値[<contributor>]");
        System.out.println("    -isoutputdate");
        System.out.println("      説明[日付を出力するかどうか。]");
        System.out.println("      型[真偽]");
        System.out.println("      デフォルト値[true]");
        System.out.println("    -ischeckbundleuriasbabel");
        System.out.println("      説明[BundleURI列が babel: から始まっていることを確認するかどうか。]");
        System.out.println("      型[真偽]");
        System.out.println("      デフォルト値[true]");
        System.out.println("    -? , -help");
        System.out.println("      説明[使い方を表示します。]");
    }

    /**
     * このバッチ処理クラスの入力パラメータの妥当性チェックを実施するためのメソッドです。
     *
     * @param input バッチ処理の入力パラメータ。
     * @throws IllegalArgumentException 入力値に不正が見つかった場合。
     */
    public void validateInput(final BlancoNLpackGeneratorTranslationFragmentToPleiadesProcessInput input) throws IllegalArgumentException {
        if (input == null) {
            throw new IllegalArgumentException("BlancoBatchProcessBatchProcess: 処理開始失敗。入力パラメータ[input]にnullが与えられました。");
        }
    }
}
